include ht48r30a-1.inc

include lcmglob.inc
include command.inc

public delay       				
public send_char  				
public send_cmd
public send_string
public initLCD
public clsLCD

dsec 	.section    'data'
dtmp    db ?
dtmp2   db ?
tmp		db ?

scode	.section	'code'					

send_cmd:
		mov tmp,a
		call busy_chk
		mov a,tmp
snd_cmd:
		mov	lcm_data,a				; pone comando en bus
		clr	lcm_ctrl.rw				; RW=W
		clr	lcm_ctrl.rs				; RS=0 (comando)
		set	lcm_ctrl.e      		; pulso en E
		clr	lcm_ctrl.e      
    	ret                                     	

busy_chk:                                       	
		set	lcm_data_ctrl   		; pone bus como entradas
		clr lcm_ctrl.rs  	 		; RS=0 (comando)
		set lcm_ctrl.rw  			; RW=R
		set lcm_ctrl.e    			; sube E
		mov a,lcm_data 				; lee bus
		clr lcm_ctrl.e              ; baja E
		sz acc.7        			; bit 7 = 0 ?	
		jmp busy_chk     			; no, loop
		clr lcm_ctrl.rw             ; s, RW=W
		clr lcm_data_ctrl   		; pone bus como salidas
		ret

send_char:
		mov tmp,a
		call busy_chk
		mov a,tmp
write_char:
		mov lcm_data,a				; pone dato en bus
		clr lcm_ctrl.rw				; RW=W
		set lcm_ctrl.rs				; RS=1 (dato)
		set lcm_ctrl.e				; pulso en E
		clr lcm_ctrl.e                             
		ret


initLCD:
		mov a,38h     		 			;  8 bit, 2 lineas, caracteres 5x7
		call snd_cmd 				

		call busy_chk				
		mov a,06h						; inc address, desplaza cursor
		call snd_cmd 				
		call busy_chk				
		mov a,0Ch						; sin cursor, ni blink 
		call snd_cmd 				
clsLCD:
		call busy_chk				
		mov	a,lcm_cls					; clear screen
		call snd_cmd  				
		call busy_chk				
		mov	a,cursor_home
		jmp snd_cmd  				

; Llamar con direccin del string (dentro del bloque de strings en ltima pgina) en A
send_string:
		mov TBLP,A
ssloop:	call busy_chk  
		tabrdl ACC		 			
		sz ACC
		jmp ssl1
		ret    				
ssl1:	call write_char 				
		inc tblp     		
		jmp ssloop


delay:	mov dtmp,a
		set dtmp2
drep:	sdz dtmp2
		jmp drep
		sdz dtmp
		jmp drep
    	ret


